> ## Documentation Index
> Fetch the complete documentation index at: https://docs.yapily.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Check Funds Availability

> Confirms whether there are available funds on the Payer account to execute a Variable Recurring Payment after obtaining the user's authorisation. 

Features:

- `VARIABLE_RECURRING_PAYMENT_FUNDS_CONFIRMATION`



## OpenAPI

````yaml /openapi-converted.json post /hosted/vrp/consent-requests/{consentRequestId}/funds-confirmation
openapi: 3.0.1
info:
  description: >-
    The Yapily API enables connections between your application and users'
    banks. For more information check out our [documentation](/introduction).


    In particular, make sure to view our [Getting
    Started](/getting-started/get-started) steps if this is your first time
    here.


    While testing the API, our list of [sandbox
    credentials](/resources/sandbox/sandbox-credentials) maybe useful.
  title: Yapily API
  version: 12.3.4
  contact:
    name: Yapily Support
    url: https://docs.yapily.com/resources/support
    email: support@yapily.com
servers:
  - url: https://api.yapily.com
security:
  - basicAuth: []
tags:
  - description: >-
      The `Application` is the base entity that is used to interact with the API
      and contains a collection of `Institution` objects. You can have multiple
      Applications associated with your account e.g. a production application
      with live access to each `Institution` and a development application with
      access to sandboxes.
    name: Application
  - description: >-
      The Users endpoints are used to manage each user (otherwise known as the
      PSU) in Yapily. Each user belongs to an Application and as a consequence,
      so do each `Consent` created for a particular `User`.
    name: Users
  - description: >-
      An `Institution` object represents any Account Serving Payment Servicing
      Provider (ASPSP) that has been integrated and is accessible through the
      Yapily APIs (ASPSPs are entities that publish Read/Write APIs to permit,
      with customer consent, payments initiated by third party providers and/or
      make their customers financial data available to third party providers via
      their API endpoints).


      Any one of the following would be represented as Institution:


      - Traditional banks e.g. Santander

      - Neo-banks e.g. Monzo

      - Building societies e.g. Cumberland Building Society
    name: Institutions
  - description: >-
      The Consents endpoints are used to manage each `Consent` created by Yapily
      in response to an authorisation created for a user.


      The `Consent` object contains data that identifies a user's consent for a
      specific `Institution` within a Yapily application. Other than the id of
      the consent, the `institution-id` for the corresponding `Institution` and
      the user identifiers (`user-uuid` and `application-user-id`), it contains
      various details that indicates how the `Consent` can be used.
    name: Consents
  - description: >-
      Before calling [Financial Data](#yapily-api-financial-data) or
      [Payments](#yapily-api-payments) endpoints, a consent from an end-user
      must be obtained.


      Consents are valid for up to 90 days for Financial Data endpoints and have
      a single-use for Payment endpoints i.e. a new consent must be obtained for
      each payment.


      NOTE: A user consent is also referred to as an 'Authorisation'.
    name: Authorisations
  - description: >-
      In order to access a user's Financial Data, you are required to request an
      [Authorisation](#tag/Authorisations) from the user to share the account
      information the bank has. Once a `consent-token` is obtained, you can call
      the necessary Financial Data endpoint(s) to retrieve the user's data.
    name: Financial Data
  - description: >-
      In order to make a Payment on behalf of a user, you are required to
      request an [Authorisation](#tag/Authorisations) from the user to authorise
      the user's account to make the payment from. Once a `consent-token` is
      obtained, you can call the necessary Payments endpoint(s) to execute a
      payment.
    name: Payments
  - description: >+
      The Notifications endpoints provide an interactive way for user to receive
      notifications according to different event-types. This feature is
      currently in private beta. Please reach out if you require access. 

    name: Notifications
  - description: >-
      Variable Recurring Payments enables transfer of money between accounts
      held by the same person or transfer of money for business payments. 


      In order to make Sweeping Variable Recurring Payments on behalf of a user,
      you are required to request an [Consent](#tag/Authorisations) from the
      user by calling the Sweeping Consent endpoint to authorise the user's
      account to make the payment. Once a `consent-token` is obtained, you can
      call the Payments endpoint to execute the Sweeping Variable Recurring
      Payments transaction. Before executing the payment, you have the option to
      confirm availability of funds in the user's account by calling the Funds
      Confirmation endpoint. 


      See [VRP Payments](/payments/vrps/additional-information) for more
      information.
    name: Variable Recurring Payments
  - description: Hosted Payment Pages endpoints for payments products
    name: Hosted Payment Pages
  - description: Hosted Consent Pages endpoints for data products
    name: Hosted Consent Pages
  - description: >-
      The constraints endpoints can be used to retrieve institution specific
      data requirements and rules that will apply when performing other
      operations.
    name: Constraints
  - description: >-
      Application Management endpoints help with creating and managing client
      sub-applications.
    name: Application Management
  - description: 'Data Plus endpoints enable our customers to enrich transaction data. '
    name: Data Plus
  - description: Webhook endpoints
    name: Webhooks
  - description: Application Beneficiaries Endpoints
    name: Application Beneficiaries
  - description: User Beneficiaries Endpoints
    name: User Beneficiaries
paths:
  /hosted/vrp/consent-requests/{consentRequestId}/funds-confirmation:
    post:
      tags:
        - Hosted Payment Pages
      summary: Check Funds Availability
      description: >-
        Confirms whether there are available funds on the Payer account to
        execute a Variable Recurring Payment after obtaining the user's
        authorisation. 


        Features:


        - `VARIABLE_RECURRING_PAYMENT_FUNDS_CONFIRMATION`
      operationId: createHostedVrpFundsConfirmation
      parameters:
        - description: Unique Identifier of the Consent Request
          in: path
          name: consentRequestId
          required: true
          schema:
            type: string
            format: uuid
        - description: >-
            __Mandatory__. The `consent-token` containing the user's
            authorisation to make the request.
          example: '{consentToken}'
          in: header
          name: consent-token
          required: true
          schema:
            type: string
        - description: >-
            The unique identifier of the sub application the request is being
            submitted on behalf of (e.g. an underlying merchant)
          in: header
          name: sub-application
          schema:
            type: string
      requestBody:
        content:
          application/json;charset=UTF-8:
            examples:
              Hosted VRP Payment Request:
                $ref: '#/components/examples/create-hosted-vrp-fund-confirmation'
            schema:
              $ref: '#/components/schemas/VrpFundsConfirmationRequest'
        required: true
      responses:
        '201':
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: '#/components/schemas/ApiResponseOfVrpFundsConfirmationResponse'
              examples:
                Hosted VRP Payment Response:
                  $ref: >-
                    #/components/examples/create-hosted-vrp-fund-confirmation-response
          description: Created
        '401':
          content:
            application/json;charset=UTF-8:
              examples:
                401 Error Response:
                  $ref: '#/components/examples/401-error-response'
              schema:
                $ref: '#/components/schemas/ApiResponseError'
          description: Error Response
        default:
          content:
            application/json;charset=UTF-8:
              examples:
                400 Error Response:
                  $ref: '#/components/examples/400-error-response'
              schema:
                $ref: '#/components/schemas/ApiResponseError'
          description: Error Response
components:
  examples:
    create-hosted-vrp-fund-confirmation:
      description: Create Hosted VRP Fund Confirmation Request
      value:
        reference: Own Account Sweeping
        paymentAmount:
          amount: 10
          currency: GBP
    create-hosted-vrp-fund-confirmation-response:
      description: Created Hosted VRP Fund Confirmation Response
      value:
        meta:
          tracingId: 0f14e900011b445fa6b6c2c4272d7321
        data:
          id: a9582f8e-08be-4cca-9f01-1ad3be96532d
          fundsAvailable:
            fundsAvailable: true
            fundsAvailableAt: '2021-06-08T10:59:35.138Z'
          reference: Own Account Sweeping
          paymentAmount:
            amount: 10
            currency: GBP
    401-error-response:
      description: 401 Error
      value:
        error:
          tracingId: 0c2d0973bdd24224a65e5d0f7d1b6154
          code: 401
          status: UNAUTHORIZED
          supportUrl: https://support.yapily.com/
          source: YAPILY
          issues:
            - type: CREDENTIALS
              code: 10700
              message: Authorization header invalid or credentials not authenticated
    400-error-response:
      description: 400 Error
      value:
        error:
          tracingId: 0c2d0973bdd24224a65e5d0f7d1b6154
          code: 400
          status: BAD_REQUEST
          supportUrl: https://support.yapily.com/
          source: YAPILY
          issues:
            - type: BAD_REQUEST
              code: 10600
              message: >-
                The server could not understand the request due to invalid
                syntax
  schemas:
    VrpFundsConfirmationRequest:
      type: object
      required:
        - paymentAmount
      properties:
        paymentAmount:
          $ref: '#/components/schemas/Amount'
        reference:
          type: string
          description: >-
            __Optional__. The reference/description associated with the VRP
            consent. Limited to a maximum of 18 characters long.
    ApiResponseOfVrpFundsConfirmationResponse:
      type: object
      properties:
        meta:
          $ref: '#/components/schemas/ResponseMeta'
        data:
          $ref: '#/components/schemas/VrpFundsConfirmationResponse'
        links:
          type: object
          additionalProperties:
            type: string
        forwardedData:
          type: array
          items:
            $ref: '#/components/schemas/ResponseForwardedData'
        tracingId:
          type: string
          writeOnly: true
        raw:
          deprecated: true
          type: array
          items:
            $ref: '#/components/schemas/RawResponse'
    ApiResponseError:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/ApiError'
        raw:
          deprecated: true
          type: array
          items:
            $ref: '#/components/schemas/RawResponse'
      description: >-
        Used to return errors from the bank from each request


        - `400` - Returned by any `POST` endpoint when the body does not conform
        to the contract

        - `401` - Returned by any endpoint when an invalid `authToken` is used
        for authentication

        - `403` - Returned by any [Financial
        Data](/api-reference#financial-data) and any
        [Payments](/api-reference#payments) endpoint when the `Consent` is no
        longer authorised to access financial data or to make a payment

        - `404` - Returned by any endpoint where there are path parameters and
        the path parameters supplied are unable to find the desired resource

        - `409` - Returned by any `POST` endpoint when creating a resource that
        conflicts with any other existing resource e.g. [Create
        User](/api-reference/addUser)

        - `424` - Returned by any [Financial
        Data](/api-reference#financial-data) and any
        [Payments](/api-reference#payments) endpoint when the feature to be
        accessed is not supported by the `Institution`.

        - `500` - Returned by any endpoint when Yapily is down. If you encounter
        any false positives, please [notify us](mailto:support@yapily.com)
      example:
        error:
          tracingId: 74b13ce8ed51419f92c5d609e04532de
          code: 424
          institutionError:
            errorMessage: >-
              {"Code":"500 Internal Server
              Error","Id":"5ff8d331-4282-41e0-b5ef-1ac9ac39f009","Message":"Technical
              Error. Please try again
              later","Errors":[{"ErrorCode":"UK.OBIE.UnexpectedError","Message":"There
              was a problem processing your request. Please try again later"}]}
            httpStatusCode: 500
          source: INSTITUTION
          status: FAILED_DEPENDENCY
    Amount:
      title: Amount Details
      required:
        - amount
        - currency
      type: object
      properties:
        amount:
          title: Amount
          type: number
          description: __Mandatory__. The monetary value
          example: 10
        currency:
          title: Currency
          type: string
          description: >-
            __Mandatory__. The [ISO 4217](https://www.xe.com/iso4217.php)
            currency code
          example: GBP
      description: __Mandatory__. Monetary Amount.
    ResponseMeta:
      type: object
      properties:
        tracingId:
          type: string
    VrpFundsConfirmationResponse:
      required:
        - paymentAmount
        - fundsAvailable
      type: object
      properties:
        id:
          type: string
        reference:
          type: string
          description: >-
            The payment reference or description. Limited to a maximum of 18
            characters long.
          example: Own Account Sweeping
        paymentAmount:
          $ref: '#/components/schemas/Amount'
        fundsAvailable:
          $ref: '#/components/schemas/VrpFundsAvailable'
    ResponseForwardedData:
      type: object
      properties:
        headers:
          type: object
          additionalProperties:
            type: string
        url:
          type: string
    RawResponse:
      deprecated: true
      type: object
      description: >-
        [DEPRECATED] Interaction (raw request and response) that occurred with
        the `Institution` in order to fulfil a request.
      properties:
        request:
          $ref: '#/components/schemas/RawRequest'
        duration:
          type: string
          format: iso8601
        headers:
          type: object
          additionalProperties:
            type: string
        resultCode:
          type: integer
          format: int32
        result:
          type: object
    ApiError:
      type: object
      description: Provides details of the error that has occurred.
      properties:
        code:
          type: integer
          description: __Mandatory__. Numeric `HTTP` status code associated with the error.
          format: int32
        institutionError:
          $ref: '#/components/schemas/InstitutionError'
        message:
          type: string
          description: >-
            __Mandatory__. Description of the exact error that has been
            experienced.
        source:
          type: string
        status:
          type: string
          description: __Mandatory__. Textual description of the `HTTP` error status type.
        tracingId:
          type: string
          description: >-
            __Optional__.  A unique identifier assigned by Yapily for the
            request that can be used for support purposes.
    VrpFundsAvailable:
      required:
        - fundsAvailable
        - fundsAvailableAt
      type: object
      properties:
        fundsAvailable:
          type: boolean
          description: __Mandatory__. The flag indicating whether the funds are available.
        fundsAvailableAt:
          type: string
          format: date-time
          description: __Mandatory__. The datetime when the funds were checked.
    RawRequest:
      type: object
      properties:
        method:
          type: string
        url:
          type: string
        requestInstant:
          type: string
          format: date-time
        headers:
          type: object
          additionalProperties:
            type: string
        body:
          type: object
        bodyParameters:
          type: object
          additionalProperties:
            type: string
        startTime:
          type: string
          format: date-time
        startedAt:
          type: string
          format: date-time
          deprecated: true
    InstitutionError:
      type: object
      description: >-
        Raw error details provided by the `Institution`, when it was the error
        source.
      properties:
        errorMessage:
          type: string
          description: Textual description of the `Institution` error.
        httpStatusCode:
          type: integer
          description: Numeric HTTP status code associated with the `Institution` error.
          format: int32
  securitySchemes:
    basicAuth:
      description: >-
        Use HTTP Basic Authentication with your Application ID as username and
        Application Secret as password. Manage credentials in the [Yapily
        Console](https://console.yapily.com/). See
        [Authentication](/api-reference/authentication) for details.
      scheme: basic
      type: http

````